/****************************************************************************
 *                    VME-OS-9    SEISLOG Software           VERSION 5.2    *
 ****************************************************************************
 *                                                                          *
 *                                  University of Bergen                    *
 *                                  Institute of Solid Earth Physics        *
 *                                  Seismological Observatory               *
 *                                  Allegaten 41, 5000 Bergen               *
 *                                  Norway. Tlf.55213419 Fax 55320009       *
 *                                  E-mail: terje.utheim@ifjf.uib.no        *
 *                                          jens.havskov@ifjf.uib.no        *
 *                                  Authors:                                *
 *                                  Terje Utheim,Jens Havskov               *
 *                                                                          *
 *                                  Date: 15.05.96                          *
 * Program: clear.c (was clear.f)                                           *
 *                                                                          *
 * Last update: S. Flower - convert from FORTRAN for QNX                    *
 *                                                                          *
 * Info: This program clears the current graphics screen                    *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/

#include <stdio.h>

main ()
{
  switch (line_typ ())
  {
  case 1:
    gmode (0);
    break;
  case 2:
    system ("/home/seislog/cls");
    break;
  default:
    fprintf (stderr, "clear: cannot determine terminal type\n");
    break;
  }
}

