#ifndef     TRUE
#define     TRUE                 1
#define     FALSE                0
#endif

#ifndef     OK
#define     OK                   0
#define     ERROR                -1
#endif

#define VERSION_NUMBER           100
#define VERSION_LETTER           'A'
#define DRIVER_PRIORITY          20          /* Priority of driver          */

#define DEFAULT_INTERRUPT_NUMBER 3
#define DEFAULT_IO_PORT          0x300
#define IO_INPORT_HIGH           2
#define USERPREFIX               "/uib/"
#define USERSERVER               "das"
#define DEFAULT_TIMER_INTERVAL   100   /* Number of 10 ms intvals for timer */ 

#define LOCAL_PROCESS_NAME       "UIB_DAS_DRIVER"

#define DEFAULT_FREQ             50         /* Default sampling rate in Hz  */
#define TIMER_SEC_START_DELAY    1L
#define TIMER_NSEC_START_DELAY   0L
#define BILLION                  1000000000L
/*                
**                       DEFINITIONS FOR HW
**
**  There is two dual converter (left-right channels, on chips A and B)
**      An interruption occurs alternatively each time that a data is valid
**      on a left or right channel, chips A and B are  synchronized.
**      The physical addresses are :
**                               chip A left  : base,     base + 1, base + 2 h
**                               chip A right : base + 4, base + 5, base + 6 h
**                               chip B left  : base + 8, base + 9, base + A h
**                               chip B right : not used
**      one bit of the highest byte indicates if the channel is right or left
*/
#define CHIP_A_LEFT_LOW          0
#define CHIP_A_LEFT_MID          1
#define CHIP_A_LEFT_HIGH         2
#define CHIP_A_RIGHT_LOW         4
#define CHIP_A_RIGHT_MID         5
#define CHIP_A_RIGHT_HIGH        6
#define CHIP_B_LEFT_LOW          8
#define CHIP_B_LEFT_MID          9
#define CHIP_B_LEFT_HIGH         10

#define CHIP_CTRL_LOW            0
#define CHIP_CTRL_HIGH           1

pid_t far rbo_int();

/* End of File */
