#include "shar_mem.h"
#include <sys/mman.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/disk.h>
#include <errno.h>

void main()
{
int      fd;                                /* return value open share      */
smod     *ptr;                              /* pointer to shared region     */
long free, used, total;
int  fh;
char *dsk,str1[30],str2[30];
extern int errno;
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"ONN_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"ONN_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}

if((fh=open("/home/seislog/dskinf",O_RDONLY | O_CREAT)) == -1){
    perror( "example1");
    exit(1);
}
if(disk_space(fh,&free,&total) == (-1)) {
    perror( "example2");printf("%d\n",errno);
    exit(1);
}
used = total - free;
ptr->freespace=(int)free/2000;
//printf( "You have %s free on your disk\n",disk_size(str1,free));
//printf( "You have %ld Mb free on your disk\n",free/2000);
//printf(" ( %ld free, %ld used of %ld blocks)\n",free, used,total);
//printf("%d %d %d\n",free/2048,used/2048,total/2048);
}
