#include <stdio.h>
#include <string.h>
#include "/home/seislog/hdr.h"
#include "/home/seislog/filedef.h"
#include "/home/seislog/shar_mem.h"
/*****************************************************************************
Defines used by the function:
*****************************************************************************/
#define HEADER 16
#define MAX_NUMOF_CHANNELS		(3)
#define EVENTS_DIR "/home/events/"
unsigned char x,y,z;
char ans;
int nn;
int  curdpx;
int  answer;
int  from;
int  to;
int  nrec;
char aar[5];
char header_qnx[1024];
char event_name[50];
char file_name[50];
char navn1[50];
char infile1[50];
int  dpx;
char NetworkName_qnx[5];
char Year_qnx[3];
char DayOfYear_qnx[4];
char Month_qnx[3];
char Day_qnx[3];
char Hour_qnx[3];
char Minute_qnx[3];
char SecMsec_qnx[8];
char Sec_qnx[4];
char Channels_qnx[3];
char SampleRate_qnx[12];
char Samp_per_Chan_qnx[10];
char Bytes_per_Sample_qnx[10];
char Unit_qnx[3];
char Bytes_per_Buffer_qnx[11];
char Bytes_per_Header_qnx[8];
char Samp_Buffer_Chan_qnx[8];
char Components_qnx[64*4];
char Station_qnx[64*4];
int year, doy, month, day, hour, min, sec;
static float vals[5000];

main()
{
int  Channels;
float sr;
char navn[30];
char chn[80];
int  bytes;
char     lbuf[80];                    /* area for input line               */
int   nchtot;
int   chan[MAXCHA];
char  noOfSamples[10];
int  type_io;
int ItemsToRead;
int ByteCount, num_of_samp;
int  BytesToRead;
float LSBValue;
int remainder ;
double f1 ;
float SeismometerPeriod;
float DampingFactor;
float GenConst;
float AmpGain;
float RecMediaGain; 
long gsd;
long HeaderPos;
int ItemsAssigned;
int i,j,k,l;
int i_channel;
int quo;
char  sample_rate[10];;
char stn_code[4];;
int IntSize, ch_index;
long pos;
short gsr_data;
long chn_data;
char* hdptr;
long  ch_offset[6];
FILE *fp;
FILE *out;
char path[50];
char line[80];
char *found=NULL, *chn_found = NULL;
char channel_header[1056];
char ch3[3];
char line3[80];
char comment[80];
char Station[5];
char Component[2];
unsigned char Model;

int SamplingRate;
	int ret_val;
	int Count =0;
int  ChannelCount = 0;

	int N ;
	char l_findfirst[100];
	int flag;
int isamp;
static short values[6000];
static int   iworkl[5000];
int   kbuf;
double tall;
double sum1;
double avg1;
double sum2;
double avg2;
double sum3;
double avg3;
int   reclength;
int   ttotal;
float ftotal;
GSR_12_Header GSR;


// Set all the values in the GSR Header

memset( &GSR, 0, sizeof( GSR_12_Header) );
	
SeismometerPeriod = 0;
DampingFactor     = 0;
GenConst          = 0;
AmpGain           = 0;
RecMediaGain      = 0; 
printf("HEADER1: %d\n",sizeof(oneChannelStructure));
printf("HEADER2: %d\n",sizeof(GSR_12_Header));
getch();
more:
sprintf(event_name,EVENTS_DIR);
printf("Enter (Q)uit or(F)ilename or (D)etection number [D=enter]:");
fflush(stdout);
fflush(stdin);
answer=getch();
printf("%c\n",answer);
fflush(stdout);
fflush(stdin);
if(answer!=0x66&&answer!=0x46&&answer!=0x64&&answer!=0x44&&answer!=0xa&&answer!=0x71&&answer!=0x51)
{
    printf("Not valid character !\n");
    goto more;
}
if(answer == 0x66 || answer == 0x46)   /* F or f                            */
{
    printf("Enter filename:\n");
    scanf("%s",file_name);
    printf("%s\n",file_name);
    strcat(event_name,file_name);
    printf("%s\n",event_name);
    goto funnet;
}
if(answer == 0x64 || answer == 0x44 || answer == 0xa) /* D or d or return   */
{
    printf("Enter DPX number:\n");
    scanf("%d",&dpx);
    printf("DPX:%d\n",dpx);
    curdpx=Get_Current_DPX();          /* get current DPX number            */
    dpxnam(dpx,infile1,&ftotal);       /* recorded, extract filename        */
    printf("Current DPX=%d File: %s\n",curdpx,infile1);
    strcat(event_name,infile1);
    printf("File to open: %s\n",event_name);
    goto funnet;
}
if(answer ==0x51 || answer == 0x71)        /* Q or q                            */
    exit(0);
funnet:
if((fp=fopen(event_name,"r+"))==NULL)
{
    printf("Error opening event file\n");
    exit(0);
}
//printf("Event file opened\n");	
for(i=0;i<1024;i++)
    header_qnx[i]=' ';
bytes=fread(header_qnx,1024,1,fp);     /* READ HEADER QNX EVENT FILE        */
Get_Header();
Channels=atoi(Channels_qnx);
k=160;
for(j=0;j<Channels;j++)
{
    for(l=j*4;l<(j*4)+4;l++)
    {
        Station_qnx[l]=header_qnx[k];
        Components_qnx[l]=header_qnx[k+4];
        k=k+1;
    }
    k=k+4;
}
/*
printf("NetworkName_qnx      : %s\n",NetworkName_qnx);
printf("Year_qnx             : %s\n",Year_qnx);
printf("DayOfYear_qnx        : %s\n",DayOfYear_qnx);
printf("Month_qnx            : %s\n",Month_qnx);
printf("Day_qnx              : %s\n",Day_qnx);
printf("Hour_qnx             : %s\n",Hour_qnx);
printf("Minute_qnx           : %s\n",Minute_qnx);
printf("SecMsec_qnx          : %s\n",SecMsec_qnx);
printf("Channels_qnx         : %s\n",Channels_qnx);
printf("SampleRate_qnx       : %s\n",SampleRate_qnx);
printf("Samp_per_Chan_qnx    : %s\n",Samp_per_Chan_qnx);
printf("Bytes_per_Sample_qnx : %s\n",Bytes_per_Sample_qnx);
printf("Unit_qnx             : %s\n",Unit_qnx);
printf("Bytes_per_Buffer_qnx : %s\n",Bytes_per_Buffer_qnx);
printf("Bytes_per_Header_qnx : %s\n",Bytes_per_Header_qnx);
printf("Samp_Buffer_Chan_qnx : %s\n",Samp_Buffer_Chan_qnx);
*/
//printf("Station_qnx          : %s\n",Station_qnx);
//printf("Components_qnx       : %s\n",Components_qnx);

ChannelCount=Channels;
if (ChannelCount >3)
{
    printf("This system can process data for three channels only.\n");
//    exit(0);
}
sprintf(navn,"IDIEM\n");
sprintf(GSR.instName,"IDIEM");
SeismometerPeriod = 0.0;
DampingFactor     = 0.0;
GenConst          = 1.25;
AmpGain           = 0.0;
RecMediaGain      = 838860.;
sscanf(NetworkName_qnx,"%4s",GSR.station);

year  = atoi(Year_qnx);
doy   = atoi(DayOfYear_qnx);
month = atoi(Month_qnx);
day   = atoi(Day_qnx);
hour  = atoi(Hour_qnx);
min   = atoi(Minute_qnx);
sec   = atoi(Sec_qnx);
//printf("%2d/%2d/%2d %3d %2d:%2d:%2d\n",year,month,day,doy,hour,min,sec);
year +=1900;
x=Hour_qnx[0];
x=x || 0xf;
y=x << 4;
x=Hour_qnx[1];
x=x << 4;
x=x >> 4;
y=y + x;
GSR.time[0]=y;

x=Minute_qnx[0];
x=x << 4;
x=x >> 4;
y=x << 4;
x=Minute_qnx[1];
x=x << 4;
x=x >> 4;
y=y + x;
GSR.time[1]=y;


x=SecMsec_qnx[0];
x=x << 4;
x=x >> 4;
y=x << 4;
x=SecMsec_qnx[1];
x=x << 4;
x=x >> 4;
y=y + x;
GSR.time[2]=y;


x=SecMsec_qnx[3];
x=x << 4;
x=x >> 4;
y=x << 4;
x=SecMsec_qnx[4];
x=x << 4;
x=x >> 4;
y=y + x;
GSR.time[3]=y;

x=Day_qnx[0];
x=x << 4;
x=x >> 4;
y=x << 4;
x=Day_qnx[1];
x=x << 4;
x=x >> 4;
y=y + x;
GSR.date[0]=y;


x=Month_qnx[0];
x=x << 4;
x=x >> 4;
y=x << 4;
x=Month_qnx[1];
x=x << 4;
x=x >> 4;
y=y + x;
GSR.date[1]=y;

sprintf(aar,"%4d\n",year);

x=aar[0];
x=x << 4;
x=x >> 4;
y=x << 4;
x=aar[1];
x=x << 4;
x=x >> 4;
y=y + x;
GSR.date[2]=y;


x=aar[2];
x=x << 4;
x=x >> 4;
y=x << 4;
x=aar[3];
x=x << 4;
x=x >> 4;
y=y + x;
GSR.date[3]=y;
sscanf(SampleRate_qnx,"%f",&sr);
SamplingRate=(int)(1./sr);

switch( SamplingRate )
{
    case 50: 
    Model = 0;
    break; 
    case 100 :
    Model = 1;
    break;
    case 150 :
    Model = 2;
    break;
    case 200 :
    Model = 3;
    break;
    case 250 :
    Model = 4;
    break;
    case 400 :
    Model = 5;
    break;
    case 500 :
    Model = 6;
    break;
    case 800 :
    Model = 7;
    break;
    case 1000 :
    Model = 8;
    break;
    default :
    {
        printf("The sampling rate  does not fall into the standard set. Can't Continue\n");
        exit(0) ;
    }
}
GSR.samplingModel = Model ;
GSR.fwv           = 26;                // Firm-ware number Temporarily hardcoded
GSR.adResolution  = 22;                // A/D resolution Temporarily hardcoded
num_of_samp =  atoi(Samp_per_Chan_qnx);
GSR.noOfSamples = (unsigned long)num_of_samp ;
GSR.noOfChannels = (unsigned char)ChannelCount ;

LSBValue =  1.0 /( RecMediaGain * GenConst );

if (LSBValue == 0.0)
{
    printf("Computed LSB value is ZERO. CAN NOT PROCEED !!!\n"); 
    exit(0);
}
GSR.channels[0].channelLSB = LSBValue;
GSR.channels[1].channelLSB = LSBValue;
GSR.channels[2].channelLSB = LSBValue;

GSR.channels[0].channelUnit[0] = 'g';
GSR.channels[1].channelUnit[0] = 'g';
GSR.channels[2].channelUnit[0] = 'g';
reclength=atoi(Bytes_per_Buffer_qnx);
ttotal=GSR.noOfSamples/SamplingRate;
printf("reclength: %d ttotal: %d\n",reclength,ttotal);
printf("Your file is %d seconds long.\n",ttotal);
printf("Enter number of seconds to skip at beginning of file:");
scanf("%d",&from);
printf("There are %d seconds left in file. How many do you want to record ?",ttotal-from);
scanf("%d",&nrec);
GSR.noOfSamples=nrec * SamplingRate;
/*   Print out available channels                                           */
/*--------------------------------------------------------------------------*/
//    cls_alp();                         /* clear and home screen             */
    avail_chan(Channels,Station_qnx,Components_qnx);
    type_io=inp_chan_plt(lbuf,Channels,chan,&nchtot);



//	strncpy(GSR.latitude, &line[51], 8);
//	strncpy(GSR.longitude, &line[60], 9);
//	strncpy(GSR.altitude, &line[70], 5);
//	IntSize= atoi(&line[76]);
	

newname:
sprintf(navn1,"%3s%03d%02d.GSR\0",GSR.station,doy,Count);
sprintf(navn,"/home/lnkdos/%3s%03d%02d.GSR\0",GSR.station,doy,Count);
if((out=fopen(navn,"r"))!=NULL)
{
    fclose(out); 
    Count++;
    if(Count <= 99)
        goto newname;
    printf("Filenames 0-99 for one day used !\n");
    exit(0);
}   
if((int)(out=fopen(navn,"a+"))!=NULL)
{
    goto found;
}else{
    printf("Cant open\n");
    exit(0);
}
found:
fwrite(&GSR,512,1,out);                /* WRITE HEADER                      */
isamp=0;
k=0;
sum1=0;
sum2=0;
sum3=0;
for(kbuf=1024/reclength+1;kbuf<5+(1024/reclength)+1;kbuf++)
{
    fseek(fp,kbuf*reclength,SEEK_SET);
    fread(iworkl,reclength,1,fp);
    for(i=0;i<SamplingRate;i++)
    {
        sum1=sum1+(float)iworkl[HEADER+(chan[0]-1)+i*Channels];
        k++;
        sum2=sum2+(float)iworkl[HEADER+(chan[1]-1)+i*Channels];
        k++;
        sum3=sum3+(float)iworkl[HEADER+(chan[2]-1)+i*Channels];
        k++;
        vals[k]=0;
        k++;
        isamp++;
    }
}
    avg1=sum1/(double)isamp;
    avg2=sum2/(double)isamp;
    avg3=sum3/(double)isamp;
    printf("DC channel1: %12.2f\n",avg1);
    printf("DC channel2: %12.2f\n",avg2);
    printf("DC channel3: %12.2f\n",avg3);

isamp=0;
k=0;
ttotal=nrec;
for(kbuf=1024/reclength+1+from;kbuf<ttotal+(1024/reclength)+1+from;kbuf++)
{
    fseek(fp,kbuf*reclength,SEEK_SET);
    fread(iworkl,reclength,1,fp);
    for(i=0;i<SamplingRate;i++)
    {
        vals[k]=(float)iworkl[HEADER+(chan[0]-1)+i*Channels]-avg1;
        k++;
        vals[k]=(float)iworkl[HEADER+(chan[1]-1)+i*Channels]-avg2;
        k++;
        vals[k]=(float)iworkl[HEADER+(chan[2]-1)+i*Channels]-avg3;
        k++;
        vals[k]=0;
        k++;
        isamp++;
    }
    for(i=0;i<k;i++)
        values[i]=(short)((double)vals[i]);
k=0;
//printf("Bytes to write: %d\n",(SamplingRate*3+SamplingRate)*2);
//getch();
    fwrite(values,(SamplingRate*3+SamplingRate)*2,1,out);
//printf("Record: %5d\n",kbuf);
}
fclose(out);
fclose(fp);
printf("File: %s written to /home/lnkdos.\n",navn);
goto more;
exit(0);
	fseek(fp, pos, SEEK_SET);
	fscanf(fp, "%2s", ch3);

	//read the event file header
	BytesToRead = 1056;
	fread(channel_header, sizeof (char) , BytesToRead, fp);

	fscanf(fp, "%2s", ch3);
	ByteCount = (int) ch3[1];
	if (ByteCount < 0 ) 
		ByteCount = abs (ByteCount ) + 1;
	BytesToRead = ByteCount ;
	ItemsToRead = BytesToRead /IntSize ;
	
	ch_index = 0;
//	long  ChannelOffset= num_of_samp  * IntSize ; 
//	int quo = ChannelOffset/128 ;
//	if (ChannelOffset% 128)
//		ChannelOffset+= quo*2 +2;
//	else 
//		ChannelOffset+= quo * 2 ;
		// add the event file channel header size ( 1040 + 16 + 2 )
//		ChannelOffset+= 1058;	

	ch_index = 0 ;
	
	for (  i_channel = 0;  i_channel < ChannelCount ; i_channel ++)
	{
		fseek(fp, HeaderPos, SEEK_SET);
		memset(comment, ' ', sizeof(comment));
		//Read the component value 
		fgets(comment, 10, fp);
		sscanf(comment, "%s%s", Station, Component);

		found = strchr(Component, 'A');   //Accelerometer readings only
		if (found)
		{
			ch_offset[ch_index++]  = HeaderPos +1058;
		}
		
		ch_offset[i_channel]  = HeaderPos +1058;
//		HeaderPos += ChannelOffset;
	}
	
	//Indicate invalid channel data if ch_index in not 3

	if (ch_index != MAX_NUMOF_CHANNELS )
	{
//		AfxMessageBox("The data file does not have any data from accelerometer.Can not continue", MB_OK, NULL);
		return 0;
	}

	ItemsToRead = BytesToRead /IntSize ;
	quo = num_of_samp /ItemsToRead ;
	remainder =  num_of_samp % (128/IntSize);
	
	N = 0;   //Data for the fourth channel
	
//	AfxGetApp()->BeginWaitCursor();
	while (num_of_samp )
	{

		for ( ch_index = 0; ch_index < MAX_NUMOF_CHANNELS; ch_index++)
		{	
			fseek(fp, ch_offset[ch_index], SEEK_SET);
			
			if (IntSize == 4 )
			{
//				fread(long_ch_data[ch_index], IntSize, ItemsToRead, fp);
			}
			else 
			{
//				fread(short_ch_data[ch_index], IntSize, ItemsToRead, fp);
			}

			ch_offset[ch_index] = ftell(fp) + 2 ;       // 2 bytes for "PP" 
		}
		
		for (  i =0 ; i < ItemsToRead; i++)
		{
			for (  j = 0  ; j < MAX_NUMOF_CHANNELS; j++)			
			{
				if (IntSize == 4 )  //read data into long arrays
				{
//					chn_data = long_ch_data[j][i];
				}
				else      //else to short arrays
				{
//					chn_data = short_ch_data[j][i];
				}
//				l_GSRHwnd.Write( &chn_data, sizeof(chn_data));	

			}
			//data for the fourth channel
			if (IntSize == 4 ) 
				chn_data = (long) N;   //N being the data for the 4th channel is 0
			else 
				chn_data = (short) N;   
//			l_GSRHwnd.Write( &chn_data, sizeof(chn_data));	
		}
		
		num_of_samp -= ItemsToRead ;
		if (num_of_samp < (128/IntSize) )
		{
			ItemsToRead = remainder ;
		}

	}
	
//	AfxGetApp()->EndWaitCursor();
	
//	l_GSRHwnd.Close();
//	sprintf( message, "Successfully converted. Saved as %s", GSRName); 
//	::MessageBox(NULL, message, "CONVERSION SUCCESSFUL", MB_OK);

	fclose(fp);
	return 1;

}
Get_Header()
{
int i;
NetworkName_qnx[0] = header_qnx[0];
NetworkName_qnx[1] = header_qnx[1];
NetworkName_qnx[2] = header_qnx[2];
Year_qnx[0]        = header_qnx[16];
Year_qnx[1]        = header_qnx[17];
DayOfYear_qnx[0]   = header_qnx[19];
DayOfYear_qnx[1]   = header_qnx[20];
DayOfYear_qnx[2]   = header_qnx[21];
Month_qnx[0]       = header_qnx[23];
Month_qnx[1]       = header_qnx[24];
Day_qnx[0]         = header_qnx[26];
Day_qnx[1]         = header_qnx[27];
Hour_qnx[0]        = header_qnx[32];
Hour_qnx[1]        = header_qnx[33];
Minute_qnx[0]      = header_qnx[35];
Minute_qnx[1]      = header_qnx[36];
for(i=0;i<7;i++)
    SecMsec_qnx[i]=' ';
SecMsec_qnx[0]     = header_qnx[38];
SecMsec_qnx[1]     = header_qnx[39];
SecMsec_qnx[2]     = header_qnx[40];
SecMsec_qnx[3]     = header_qnx[41];
SecMsec_qnx[4]     = header_qnx[42];
SecMsec_qnx[5]     = header_qnx[43];
Sec_qnx[0]         = header_qnx[38];
Sec_qnx[1]         = header_qnx[39];
Sec_qnx[2]         = '\0';
Channels_qnx[0]    = header_qnx[62];
Channels_qnx[1]    = header_qnx[63];
for(i=0;i<12;i++)
    SampleRate_qnx[i]='\0';
SampleRate_qnx[0]  = header_qnx[71];
SampleRate_qnx[1]  = header_qnx[72];
SampleRate_qnx[2]  = header_qnx[73];
SampleRate_qnx[3]  = header_qnx[74];
SampleRate_qnx[4]  = header_qnx[75];
SampleRate_qnx[5]  = header_qnx[76];
SampleRate_qnx[6]  = header_qnx[77];
SampleRate_qnx[7]  = header_qnx[78];
SampleRate_qnx[8]  = header_qnx[79];
Samp_per_Chan_qnx[0] = header_qnx[80];
Samp_per_Chan_qnx[1] = header_qnx[81];
Samp_per_Chan_qnx[2] = header_qnx[82];
Samp_per_Chan_qnx[3] = header_qnx[83];
Samp_per_Chan_qnx[4] = header_qnx[84];
Samp_per_Chan_qnx[5] = header_qnx[85];
Samp_per_Chan_qnx[6] = header_qnx[86];
Samp_per_Chan_qnx[7] = header_qnx[87];
Samp_per_Chan_qnx[8] = '\0';

Bytes_per_Sample_qnx[0] = header_qnx[95];
Bytes_per_Sample_qnx[1] = '\0';

Unit_qnx[0]             = header_qnx[96];
Unit_qnx[1]             = header_qnx[97];
for(i=0;i<10;i++)
    Bytes_per_Buffer_qnx[i]='\0';
Bytes_per_Buffer_qnx[0] = header_qnx[104];
Bytes_per_Buffer_qnx[1] = header_qnx[105];
Bytes_per_Buffer_qnx[2] = header_qnx[106];
Bytes_per_Buffer_qnx[3] = header_qnx[107];
Bytes_per_Buffer_qnx[4] = header_qnx[108];
Bytes_per_Buffer_qnx[5] = header_qnx[109];
Bytes_per_Buffer_qnx[6] = header_qnx[110];
Bytes_per_Buffer_qnx[7] = header_qnx[111];
Bytes_per_Header_qnx[0] = header_qnx[112];
Bytes_per_Header_qnx[1] = header_qnx[113];
Bytes_per_Header_qnx[2] = header_qnx[114];
Bytes_per_Header_qnx[3] = header_qnx[115];
Bytes_per_Header_qnx[4] = header_qnx[116];
Bytes_per_Header_qnx[5] = '\0';
Samp_Buffer_Chan_qnx[0] = header_qnx[122];
Samp_Buffer_Chan_qnx[1] = header_qnx[123];
Samp_Buffer_Chan_qnx[2] = header_qnx[124];
Samp_Buffer_Chan_qnx[3] = header_qnx[125];
Samp_Buffer_Chan_qnx[4] = header_qnx[126];
Samp_Buffer_Chan_qnx[5] = header_qnx[127];
Samp_Buffer_Chan_qnx[6] = '\0';
}
/*-------------------------------------------------------------------------*/
/* Get filenames on old detections and their duration                      */
/*-------------------------------------------------------------------------*/
dpxnam(i,infile,ttotal)
int i;
char* infile;
float* ttotal;
{
    FILE    *det;
    int     nn;
    int     kl;
    char    detrec[512];
    char    dur[16];
    int     istart;
    float   locdur;
    det=fopen(DETECTION,"r");
    nn=i/EVTSIZ;
    kl=nn*EVTSIZ;
    istart=(i-1-kl)*512;
    fseek(det,istart,0);
    fread(detrec,512,1,det);
    for(kl=0;kl<DIRNAMLEN;kl++)
        infile[kl]='\0';
    for(kl=0;kl<25;kl++)
        infile[kl]=detrec[kl+208];
    for(kl=0;kl<16;kl++)
        dur[kl]=detrec[kl+64];
    sscanf(dur,"%f8.3\n",&locdur);
    *ttotal=locdur;
    fclose(det);
}
/*-------------------------------------------------------------------------*/
/* Get current DPX number                                                  */
/*-------------------------------------------------------------------------*/
Get_Current_DPX()
{
    FILE    *det;                        /* pointer current detection no.  */
    int     curdpx;                      /* current dpx number             */
    det=fopen(DETNUMBER,"r");
    fscanf(det,"%d",&curdpx);
    fclose(det);
    return(curdpx);
}
/*------------------------------------------------------------------------*/
/* Print out available channels                                           */
/*------------------------------------------------------------------------*/
avail_chan(nchan,stcode,comp)
int nchan;
char *stcode;
char *comp;
{
    int k1,k2,cnt;
    printf("Available channels:");
    cnt=0;
    putchar(0x0d);
    putchar(0x0a);
    for(k1=0;k1<nchan;k1++)
    {
        printf("%4d ",k1+1);
        for(k2=k1*4;k2<k1*4+4;k2++)
            printf("%c",stcode[k2]);
        for(k2=k1*4;k2<k1*4+4;k2++)
            printf("%c",comp[k2]);
        cnt=cnt+1;
        if(cnt==5)
        {
            putchar(0x0d);
            putchar(0x0a);
            cnt=0;
        }
    }
    putchar(0x0d);
    putchar(0x0a);
}
inp_chan_plt(lbuf,nchan,chan,nchtot)
char*    lbuf;
int      nchan;
int      *chan;
int      *nchtot;
{
FILE     *fp;
int      i;
int      k;
int      j;
int      p;
int      cnt;
int      spcnt;
int      kanaler[65];
char     karak[80];
int      tel;
int      let;
char     temp[10];
char     kopi[80];
tel=0;
fp=stdin;
again:
for(k=0;k<nchan;k++)
    chan[k]=0;
crlf();
printf("                     Enter 3 channels:");
crlf();
printf("                     -----------------");
crlf();
printf("Enter channel numbers on one line with space in between, finish with RETURN");
crlf();
crlf();
flu();
for(i=0;i<80;i++)
{
    let=getch();
    putchar(let);
    fflush(stdin);
    fflush(stdout);
    karak[i]=let;
    if(let == 0xa)
        goto tolk;
}
tolk:
if(karak[0]==' ')                      /* check first character is SPACE ?  */
    return(-1);                        /* not allowed return error -1       */
cnt=0;
for(k=0;k<80;k++)
{

    if(karak[k] != 0x0a)
    {
        cnt=cnt+1;
    }else{
        k=k-1;
        goto out;
    }
}
out:
if(karak[0]==0xa)                      /* return in first pos, ch 1,2,3     */
{
    chan[0]=1;
    chan[1]=2;
    chan[2]=3;
    *nchtot=3;
    return(0);
}
//printf("Number of characters:%d\n",cnt);
if(karak[cnt-1]==' ')                   /* check if last character is SPACE  */
    return(-2);                        /* not allowed return error -2       */
for(i=0;i<cnt;i++)                     /* check for non numeric or non space*/
{
    if(karak[i] < '0' && karak[i] > '9') /* is it a positive number ?         */
    {                                  /* no                                */
        if(karak[i]!=' ')               /* is it a space ?                   */
            return(-3);                /* no, return error -3               */
    }
}
for(i=0;i<cnt;i++)                     /* check for more than 1 space betwee*/
{
    if(karak[i]==' ')
    {
        if(karak[i+1]==' ')
            return(-4);                /* yes, return error -4              */
    }
}
spcnt=0;
for(i=0;i<cnt;i++)
{
    if(karak[i] == ' ')
        spcnt=spcnt+1;                 /* increment spaces                  */
}
*nchtot=spcnt+1;                       /* number of channels specified      */
putchar(0x0d);
putchar(0x0a);
if(spcnt+1 > 3)
{
    printf("You can specify MAX 3 channels !\n");
    goto again;
}
//printf("Number of channels specified:%d",spcnt+1);
k=0;
j=0;
for(p=0;p<5;p++)
    temp[p]='\0';
for(i=0;i<80;i++)
    kopi[i]=' ';
for(i=0;i<cnt;i++)
    kopi[i]=karak[i];
for(i=0;i<cnt+1;i++)
{
    if(kopi[i] != ' ')
    {
        temp[k]=karak[i];
        k=k+1;
    }else{
        k=0;
        sscanf(temp,"%d",&kanaler[j]);
        j=j+1;
        for(p=0;p<5;p++)
            temp[p]='\0';
    }
}
//printf("\n");
for(i=0;i<spcnt+1;i++)
{
    putchar(0x0d);
    putchar(0x0a);
//    printf("%d %d",i,kanaler[i]);
}
for(i=0;i<spcnt+1;i++)
    chan[i]=kanaler[i];
return(1);                             /* return all well                   */
}
flu()
{
fflush(stdin);
fflush(stdout);
}
crlf()
{
putchar(0xd);
putchar(0xa);
}