#include <stdio.h>
#include <math.h>
#include <string.h>
#include <dirent.h>
#include <conio.h>
#include <graph.h>
#define  XL 600.
#define  YL 450.
#define  YDISP 120

FILE*    dag;
DIR      *dirp;
struct   dirent *direntp;
char     filenames[500][50];
char     names[100];
char     head[10000];
static   int  datain[5000];
static   int  datapl[90000];

main()
{
int      maxi;
int      displm;
int      reclength;
int      ind;
int      chan;
int      total;
int      rsrate;
float    rate;
int      totsmp;
int      num_cha;
int      cur_min;
int      cur_rcl;
int      p;
int      ii;
int      i,j,k,l;                            /* counter                           */
float    scfac;                        /* scaling factor                    */
float    maxa;                         /* max amplitude                     */
float    sum;
float    avg;
int      hour;
int      minute;
float    secs;
int      day;
int      month;
int      year;
int      order;
char     type[10];
float    fltlo;
float    flthi;
char     name[50];
char     fname[50];
char*    hdptr=head;

sum=0.;
p=1;

dirp=opendir("/home/resamp");
k=0;
for(;;)
{
    direntp = readdir(dirp);
    if(direntp == NULL) break;
    sprintf(names,"%s",direntp->d_name);
    if(names[0]>='0' && names[0] <= '9')
    {
        sprintf(filenames[k],"%s",direntp->d_name);
        k++;
    }
}
//for(i=0;i<(k-1);i++)
//    printf("%5d %s\n",i,filenames[i]);
//system("ls /home/resamp");

system("/home/seislog/lgs_res");
printf("Enter filenumber:");
scanf("%d",&k);
sprintf(name,"%s",filenames[k]);
sprintf(fname,"/home/resamp/");
strcat(fname,name);
dag=fopen(fname,"r");

fread(head,200,1,dag);
sscanf(hdptr,"%2d",&hour);
hdptr+=3;
sscanf(hdptr,"%2d",&minute);
hdptr+=3;
sscanf(hdptr,"%6.3f",&secs);
hdptr+=10;
sscanf(hdptr,"%2d",&day);
hdptr+=3;
sscanf(hdptr,"%2d",&month);
hdptr+=3;
sscanf(hdptr,"%2d",&year);
hdptr+=10;

sscanf(hdptr,"%8d",&reclength);
hdptr+=8;
sscanf(hdptr,"%8d",&num_cha);
hdptr+=8;
sscanf(hdptr,"%8d",&total);
hdptr+=8;
sscanf(hdptr,"%6d",&rsrate);
hdptr+=8;
sscanf(hdptr,"%f10.8",&rate);
hdptr+=11;
sscanf(hdptr,"%8d",&totsmp);
hdptr+=8;
sscanf(hdptr,"%8d",&order);
hdptr+=14;
sscanf(hdptr,"%s\n",type);
hdptr+=2;
sscanf(hdptr,"%f8.3",&fltlo);
hdptr+=8;
sscanf(hdptr,"%f8.3",&flthi);
hdptr+=8;
hdptr+=8;
hdptr+=8;
hdptr+=8;
hdptr+=8;
sscanf(hdptr,"%8d",&cur_min);
hdptr+=8;
sscanf(hdptr,"%8d",&cur_rcl);
printf("RECLENGTH: %d\n",reclength);
printf("NUM_CHA  : %d\n",num_cha);
printf("TOTAL    : %d\n",total);
printf("RSRATE   : %d\n",rsrate);
printf("RATE     : %10.8f\n",rate);
printf("TOTSMP   : %d\n",totsmp);
printf("ORDER    : %d\n",order);
printf("TYPE     : %s\n",type);
printf("FLTLO    : %f\n",fltlo);
printf("FLTHI    : %f\n",flthi);
printf("CUR_MIN  : %d\n",cur_min);
printf("CUR_RCL  : %d\n",cur_rcl);
if(cur_min == 0)
{
    printf("The file contains less than 1 minute of data. Try later.\n");
    exit(0);
}
if(cur_min < total)
{
    total=cur_min;
    totsmp=cur_rcl;
}
scfac=XL/(float)totsmp;                /* pixels per value                  */
printf("Scaling factor x-axis: %f\n",scfac);
fseek(dag,reclength,SEEK_SET);
getch();
displm=100;
if(p==1)
{
    _setvideomode(_VRES16COLOR);
    _setcolor(1);
    _rectangle(_GFILLINTERIOR,0,0,(int)XL,(int)YL);
    _setcolor(15);
    _rectangle(_GBORDER,0,0,(int)XL,(int)YL);
}
for(chan=0;chan<num_cha;chan++)
{
    ind=0;
    sum=0;
    for(i=0;i<total;i++)
    {
        fseek(dag,reclength*(i+1),SEEK_SET);
        fread(datain,reclength,1,dag);
        for(ii=0;ii<60*rsrate;ii++)
        {
            datapl[ind]=datain[ii*3+chan];
//printf("%5d %8d\n",ind,datapl[ind]);
            ind++;
        }
    }
    for(i=0;i<(60*total*rsrate);i++)
        sum=sum+(float)datapl[i];
    avg=sum/(float)(60*total*rsrate);
//    printf("AVG:%f\n",avg);
    for(i=0;i<(60*total*rsrate);i++)
    {
        datapl[i]=datapl[i]-(int)avg;
//printf("%5d %8d\n",i,datapl[i]);
    }
    maxi=0;
    for(i=0;i<(60*total*rsrate);i++)
    {
        if(abs(datapl[i]) > maxi)
            maxi=abs(datapl[i]);
    }
    for(i=0;i<(60*total*rsrate);i++)
    {
        datapl[i]=(int) (((float)(datapl[i])/(float)(maxi))*75.); 
    }
        
if(p==1)
{
    _setcolor(15);
    _moveto(0,(int)((float)datapl[0])+displm);
    for(i=0;i<60*total*rsrate;i++)
        _lineto(i*scfac,(int)((float)datapl[i])+displm);
}
    displm=displm+YDISP;
    getch();
}
}
