/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:15/05/95                       */
/* Program:PRO_ALL                                                          */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* Program to copy events from QNX partition to DOS partition. Filenames are*/
/* converted to 8 letters.                                                  */
/*                                                                          */
/****************************************************************************/
#include <stdio.h>                 
#include <errno.h>

main ()
{
char    com[80];
char    dum[80];
char    ch;
char    fnam1[80];
char    fnam2[80];
char    syscall[100];
char    name[80];
int     nbyte;
int     k;
int     i;
int     year;
int     month;
int     day;
int     hour;
int     min;
int     sec;
int     answer;
FILE*   evt;
FILE*   lst;
system("rm -f /home/seislog/evt.lis");
printf("What files to process:\n");
scanf("%s",dum);
if(dum[0]=='a' && dum[1]=='l' && dum[2]=='l')
{
    sprintf(syscall,"ls /home/events/*T.*>/home/seislog/evt.lis\0");
    system(syscall);
}else{
    sprintf(syscall,"ls %s > /home/seislog/evt.lis\0",dum);
    system(syscall);
}
system("more /home/seislog/evt.lis");
if((evt=fopen("/home/seislog/evt.lis","r"))==NULL)
{
    fclose(evt); 
    printf("Could not open file containing events summary\n");
    exit(0);
}
system("rm -f /home/work/location");
/*--------------------------------------------------------------------------*/
/*                read in names until EOF                                   */
/*--------------------------------------------------------------------------*/
i=1;
for(;;)
{
if(fscanf(evt,"%s",com) !=1)
    goto fin;
//    nbyte=fread(com,40,1,evt);
//    if(nbyte==0)                       /* if no more names => finish        */
//        goto fin;
//    printf("%3d  ",i);
//    com[39]='\0';
printf("%5d %s\n",i,com);

//fprintf(lst,"%5d %s\n",i,com);

sprintf(syscall,"pk %s\n",com);
system(syscall);
    i=i+1;
}
fin:
fclose(lst);
printf("Number of files:%d\n",i-1);    
}

/*-------end: configure_ring----------------------------------------------*/
