#include <stdio.h>
#include <math.h>
#include <conio.h>
#include <graph.h>
#define XL 400.
#define YL 200.

main()
{
int      NN;                           /* number of complex data points     */
int      NN2;                          /* number of locations in real array */
int      i;                            /* counter                           */
int      isign;                        /* 1/-1 forward/inverse FFT          */
float    nyquist;                      /* Nyquist frequency                 */
float    scfac;                        /* scaling factor                    */
float    maxa;                         /* max amplitude                     */
float    data[2050];                   /* data for transform                */
float    spec[1050];                   /* specter                           */
float freq,pi,f;
pi=3.14159;

printf("Enter NN:");
scanf("%d",&NN);
NN2=NN*2;
printf("Enter frequency:");
scanf("%f",&freq);
printf("Enter srate:");
scanf("%f",&f);
nyquist=1.0/(2.0*f);
printf("Nyquist: %12.2f Hz\n",nyquist);
scfac=XL/(NN/2);
for(i=1;i<NN2;i +=2)
{
    data[i]=sin(pi*f*(float)i*freq);
    data[i+1]=0.0;
}
isign=1;
four1(data,NN,isign);                  /* do FFT                            */
ex_spec(data,NN,spec);                 /* extract specter                   */

maxa=0.0;
for(i=0;i<=NN/2;i++)                   /* find max value to scale specter   */
{
   if(spec[i] > maxa)
       maxa=spec[i];
}
for(i=0;i<=NN/2;i++)                   /* scale specter to max 1.0          */
    spec[i]=spec[i]/maxa;

scfac=XL/(float)(NN/2);              /* pixels per value                  */

_setvideomode(_VRES16COLOR);
_setcolor(1);
_rectangle(_GFILLINTERIOR,0,0,(int)XL,(int)YL);
_setcolor(0);
_rectangle(_GFILLINTERIOR,0,(int)YL+1,(int)XL,(int)YL+21);
_setcolor(14);
_moveto(0,(int)YL);

_lineto((int)XL,(int)YL);
if(nyquist <= 25.)
{
    for(i=0;i<=(int)nyquist;i=i+1)
    {
        _moveto((int) ( (float)i*(XL/nyquist)),(int)YL);
        _lineto((int)((float)i*(XL/nyquist)),(int)YL+5);
    }
}
for(i=0;i<=(int)nyquist;i=i+10)
{
    _moveto((int) ( (float)i*(XL/nyquist)),(int)YL);
    _lineto((int)((float)i*(XL/nyquist)),(int)YL+10);
}
for(i=0;i<=(int)nyquist;i=i+100)
{
    _moveto((int) ( (float)i*(XL/nyquist)),(int)YL);
    _lineto((int)((float)i*(XL/nyquist)),(int)YL+20);
}
_setcolor(15);
_moveto(0,(int)YL);
for(i=0;i<=NN/2;i++)
    _lineto(i*scfac,(int)(spec[i]*YL*-1.+YL));
getch();
}
