/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 7.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55583408 +47 55583419      */
/*                                      Fax  +47 55589669                   */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:10/03/98                       */
/* Program:SRC_DST                                                          */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* Make source upgrade floppy of SEISLOG                                    */
/*                                                                          */
/****************************************************************************/
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#ifdef __USAGE
------------------------------------------------------------------------------
%C                                         Date: 17/09/98     Version 7.50
------------------------------------------------------------------------------
Description: Program makes compressed tar saveset of source upgrade from
             directory /home/src to floppy. ONLY C-files and H files are
             included. NB ! This is not a complete distribution floppy.

Usage:       src_dst (no parameters)
-----------------------------------------------------------------------------
#endif
main()
{
    if(chdir("/home/src") != 0)
        exit(0);
    system("tar -cvf - . | freeze | vol -w /dev/fd0");
//    system("tar -cvf - .  saveset");
/*    system("tar -cvf - . | vol -w /dev/fd0");*/

}
