/****************************************************************************/
/*V PC QNX SEISLOG Software                                   Version 7.00  */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55583408 +47 55583419      */
/*                                      Fax  +47 55589669                   */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*D                                     Date: 21/05/99                      */
/* Program:                                                                 */
/*                                                                          */
/* Last update:                                                             */
/*U                                                                         */
/* Program description:                                                     */
/*                                                                          */
/* Program removes old existing links from ringbuffer filesystem when new   */
/* links are made.                                                          */
/*                                                                          */
/****************************************************************************/     

#include <limits.h>
#include <dirent.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
char buf[100];
char cmd[100];
char navn[100];
char str1[6];
char str2[6];
void main(argc,argv)
int argc;
char *argv[];
{
    DIR *dirp;
    struct dirent *direntp;
    FILE *links;
    int n;
    int len;
    int ecode = 0;
    if(argc==2)
    {
        sprintf(navn,"%s\0",argv[1]);
//    printf("Input name: %s\n",navn);
//printf("Look : %s\n",navn);
    }else{
    exit(0);
    }
    str1[0]=navn[13];
    str1[1]=navn[14];
    str1[2]=navn[15];
    str1[3]=navn[16];
    str1[4]=navn[17];
    str1[5]='\0';
    dirp=opendir("/home/rngbuf");
    if(dirp!=NULL)
    {
        for(;;)
        {
            direntp=readdir(dirp);
            if(direntp==NULL)break;
            sprintf(cmd,"%s\n",direntp->d_name);
            str2[0]=cmd[0];
            str2[1]=cmd[1];
            str2[2]=cmd[2];
            str2[3]=cmd[3];
            str2[4]=cmd[4];
            str2[5]='\0';
            n=strcmp(str1,str2);
            if(n==0)
            {
//            printf("Found: %s\n",cmd);
                sprintf(buf,"rm -f /home/rngbuf/%s",cmd);
//            printf("REMOVE: %s\n",buf);
                system(buf);
            }
        }
        closedir(dirp);
    }
}