/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:23/09/95                       */
/* Program:CLS                                                              */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* This program clears the screen and put the cursor to home position.      */
/* Works with VT100 or compatible or QNX.                                   */
/*                                                                          */
/****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <sys/qnxterm.h>
#ifdef __USAGE
------------------------------------------------------------------------------
%C                                             Date: 03/03/98     Version 7.00
------------------------------------------------------------------------------
Description: This program will clear the screen and position the cursor home.

Usage:       cls (no parameters)
#endif

main()
{
if(term_load() == -1) {
    fprintf(stderr,"term_load error. errno= %d\n",errno);
    exit(0);
}
term_clear(TERM_CLS_SCRH);
}
