/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:08/08/95                       */
/* Program:CPU                                                              */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* List out /dd/error/up_cpu (current logfile) or /dd/error/up_cpu_old      */
/* (previous logfile)                                                       */
/*                                                                          */
/****************************************************************************/
#include <stdio.h>
#include <errno.h>
#include "filedef.h"
#define  ERROR -1
FILE     *tims;
int c;
main ()
{
new_file:
cls_q();

if((tims=fopen(UPSEICPU,"r"))==NULL)
{
    printf("Log file does not exist\n");
    exit(0);
}
fclose(tims);

printf("                NEW LOG: CPU STARTED - CPU STOPPED\n");
printf("                ==================================\n");
system("cat /home/error/up_cpu");
new_input:
printf("Listing of New log-Old log or stop (N=>new,O=>old,cr=>stop) ?");
fflush(stdout);
fflush(stdin);
c=getch();                    /* Read 1 character from terminal         */
if(c != 0x4f && c != 0x6f && c != 0x4e && c != 0x6e && c != 0xa)
{
    printf("Input should be n,o or cr\n");
    goto new_input;
}
if(c == 0x0a)
{
    printf("\n");
    exit(0);
}
if(c==0x4f || c==0x6f)
{
    cls_q();

if((tims=fopen(UPCPUOLD,"r"))==NULL)
{
    printf("Old log file does not exist, try New log file\n");
    goto new_input;
}
fclose(tims);

    printf("                OLD LOG: CPU STARTED - CPU STOPPED\n");
    printf("                ===================================\n");
    system("cat /home/error/up_cpu_old");
    goto new_input;
}else{
    goto new_file;
}
}

cls()
{
    putchar(0x1b);
    putchar(0x5b);
    putchar(0x32);
    putchar(0x4a);
    putchar(0x1b);
    putchar(0x5b);
    putchar(0x3b);
    putchar(0x48);
}
cls_q()
{
    putchar(0x1b);
    putchar(0x4a);
    putchar(0x0c);
}